#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <strings.h>

#include "cdstatus_cddb.h"
#include "build_output_filename.h"

void buildOutputFilename(const cdstatus_args * cdsargs, unsigned int counter, char *filename_out)
{
    char filename[1024];
    char filename2[1024];
    char scratch[3];
    char pathname[1024];
    unsigned int index = 0;

    pathname[0] = '\0';

    if (cdsargs->cddb == 0)
    {
        (void)snprintf(filename, 1023, "%s%02u", cdsargs->basename, counter);
    }
    else
    {

        /* If you're using --cddb and/or --format WITHOUT .wav output, you're either crazy
         * or doing something really complicated, but I'll support your nutso self */
        if (cdsargs->format_on==0)
        {
            (void)snprintf(filename, 1023, "%s/%s/%s_-_%s_-_%02u_-_%s", artist_name, album_name, artist_name, album_name, counter, trackinfo[counter].title);
        }

        /* Parse format string */
        else
        {
            filename[0] = '\0';

            while (index < (unsigned int)strlen(cdsargs->format))
            {
                if (cdsargs->format[index] != '#')
                {
                    strncat(filename, &(cdsargs->format[index]), 1);
                    ++index;
                }
                else
                {
                    if (!strncasecmp(&(cdsargs->format[index]), "#artist#", strlen("#artist#")))
                    {
                        strcat(filename, artist_name);
                        index += strlen("#artist#");
                    }
                    else if (!strncasecmp(&(cdsargs->format[index]), "#album#", strlen("#album#")))
                    {
                        strcat(filename, album_name);
                        index += strlen("#album#");
                    }
                    else if (!strncasecmp(&(cdsargs->format[index]), "#trknum#", strlen("#trknum#")))
                    {
                        (void)snprintf(scratch, 3, "%02u", counter);
                        strncat(filename, scratch, (1024-strlen(filename)));
                        index += strlen("#trknum#");
                    }
                    else if (!strncasecmp(&(cdsargs->format[index]), "#trkname#", strlen("#trkname#")))
                    {
                        strcat(filename, trackinfo[counter].title);
                        index += strlen("#trkname#");
                    }
                    else
                    {
                        strncat(filename, &(cdsargs->format[index]), 1);
                        ++index;
                    }
                }
            }
        }
    }

    if (cdsargs->waveout!=0)
    {
        if(cdsargs->lame!=0)
        {
            strcat(filename, ".mp3");
        }
        else
        {
            strcat(filename, ".wav");
        }
    }
    else
    {
        strcat(filename, ".raw");
    }

    (void)snprintf(filename2, 1023, "%s/%s", cdsargs->outputdir, filename);
    strcpy(filename, filename2);
    strncpy(filename_out, filename, 1023);

    return;
}
