#ifndef CDDB_CALC_DISCID_H
#define CDDB_CALC_DISCID_H

#include "cd_toc_info.h"

/** calculates Disc ID for cddb database lookup.
  * This performs the work of calculating the DISC id which is used to query
  * the cddb server for track information. The code here was modified from
  * that found on the freedb.org site example code.
  * @param[in] tracks the number of tracks on the cd
  * @param[in] cdtocinfo the TOC info for the cd
  * return the calculated DISC ID
  */
unsigned int calcDiscId(unsigned int tracks, const cd_toc_info * cdtocinfo);

#endif
