#include "cddb_connect_to_server.h"

#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>

int cddbConnectToServer(const char * cddb_site)
{
	/* network related */
	int client_sock;
	struct sockaddr_in dest_addr;
	struct hostent *host_info;
	
	memset(&dest_addr, 0, sizeof(dest_addr));

	client_sock = socket(AF_INET, SOCK_STREAM, 0);
	if (client_sock == -1)
	{
		perror("Error, unable to create client socket for CDDB lookup");
		return 0;
	}
	dest_addr.sin_family = AF_INET;
	dest_addr.sin_port = htons(CDDB_PORT);
	host_info = gethostbyname(cddb_site);
	if (host_info == NULL)
	{
		printf("Unable to look up the host address of the CDDB site %s.\n", cddb_site);
		if (h_errno == HOST_NOT_FOUND)
		{
			(void)puts("Host not found.");
		}
		return 0;
	}
	memcpy(&(dest_addr.sin_addr.s_addr), host_info->h_addr, (size_t)host_info->h_length);
	/*I hope this doesn't break stuff... */
	/*free(host_info->h_name);
	free(host_info);*/
	/*end of breaking stuff */
	memset(&(dest_addr.sin_zero), 0, 8);
	if(connect(client_sock, (struct sockaddr *) &dest_addr, (socklen_t)sizeof(struct sockaddr))==-1)
	{
		perror("Unable to connect to remote cddb host.  Aborting lookup");
		return 0;
	}

#ifdef DEBUG
	else
	{
		(void)puts("Connected to cddb lookup server.");
	}
#endif /* DEBUG */

	return client_sock;
}
