#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "cddb_hearken.h"
#include "cdstatus_cddb.h"

int hearken(int client_sock, void *buffer)
{
	ssize_t data_size;
	int result;

	memset(buffer, 0, BUFFSIZE);
	data_size = recv(client_sock, buffer, BUFFSIZE - 1, 0);
	if (data_size == -1)
	{
		perror("Error while receiving data from cddb site. Aborting Lookup");
		return -1;
	}

#ifdef DEBUG
	else
	{
		printf("Received %d bytes of data from server: \n%s\n", data_size, (char *) buffer);
	}
#endif /*  */
	if(sscanf((const char *) buffer, "%d", &result)!=1)
	{
		(void)puts("Error parsing/matching input, exiting.");
		exit(EXIT_FAILURE);
	}
	return result;
}
