#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#include "cdstatus_cddb.h"
#include "open_output_file.h"

FILE * openOutputFile(const char *filename, int lame, unsigned int track, const char *lameopts)
{
	char *last_slash;
	char syscmd[2048];
	char pathname[1024];
	FILE * output_file;

#ifdef DEBUG
	printf("Handed file to create: %s\n", filename);
#endif
	/*
	if(chdir("/")==-1)
	{
		perror("Error switching to directory");
		exit(EXIT_FAILURE);
	}
	*/

	last_slash = strrchr(filename, '/');
	if (last_slash == NULL)
	{
		(void)puts("Error, directory portion of name not found. Exiting");
		exit(EXIT_FAILURE);
	}
	strncpy(pathname, filename, (size_t)(last_slash - filename));
	pathname[(last_slash - filename)] = '\0';
#ifdef DEBUG
	printf("Path component of file to create: %s\n", pathname);
#endif
	(void)snprintf(syscmd, 2048, "mkdir -p \"%s\"", pathname);
#ifdef DEBUG
	printf("Issuing command: %s\n", syscmd);
#endif
	if(system(syscmd)==-1)
	{
		perror("Error executing command to create directory");
		exit(EXIT_FAILURE);
	}
	
	/* If we're piping to lame, open the pipe and pass the neccessary stuff, otherwise, just open the file */
	if(lame==1)
	{
		(void)snprintf(syscmd, 2048, "lame -S %s --tt \"%s\" --ta \"%s\" --tl \"%s\" --ty \"%d\" --tn \"%u\" - \"%s\"",lameopts,trackinfo[track].title, artist_name, album_name, album_year, track, filename);
#ifdef DEBUG
		printf("Track Genre: %s\n",album_genre);
		printf("Using lame with: %s\n\n",syscmd);
		fflush(stdout);
#endif
		output_file = popen((const char *)syscmd, "w");
		if(output_file==NULL)
		{
			perror("Error creating pipe to lame");
			exit(EXIT_FAILURE);
		}
	}
	else
	{
		output_file = fopen(filename, "w");
	}

	if (output_file == NULL)
	{
		perror("Error creating output file");
		exit(EXIT_FAILURE);
	}
	return output_file;
}
