#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>

#include "cdstatus.h"

void printHelp(void)
{
    (void)puts("Usage summary (see README file for full details):\n\n"
         "--version          displays version information and then exits\n\n"
         "--help             displays this usage summary and exits\n\n"
         "--reset            resets the drive internally.  normally\n"
         "                   requires root privileges\n\n"
         "--drive /dev/path/ overrides the default cdrom drive path of\n"
         "                   /dev/cdrom\n\n"
         "--outputdir /path/ specifies a directory for file output other\n"
         "                   than the default of the current working\n"
         "                   directory\n\n"
         "--retries X        overrides the default number of retries for\n"
         "                   failed reads. Default is 3\n\n"
         "--start X          specifies a track to start audio extraction\n"
         "                   from. Default is 1\n\n"
         "--stop X           specifies a track to stop audio extraction\n"
         "                   at. Default is last track on cd\n\n"
         "--readtest\n"
         "--rip              perform a digital audio extraction (rip) of\n"
         "                   tracks. --rip is an alias for --readtest and\n"
         "                   has the same function\n\n"
         "--waveout          now redundant, because .wav file output is\n"
         "                   the default, this also sets --readtest\n\n"
         "--rawout           specifies the old headerless files for\n"
         "                   output, which will contain exactly the data\n"
         "                   on the cd.  not playable by most music\n"
         "                   programs without passing a lot of audio info\n"
         "                   (2 channel, 44.1khz 16-bit signed, etc)\n\n"
         "--basename name    specifies to create file names of the form\n"
         "                   nameXX.wav where XX is the track number,\n"
         "                   instead of the default of trackXX.wav.\n\n"
         "--readchunk X      specifies to read X frames of audio data at\n"
         "                   a time, instead of 1 by 1.  this will\n"
         "                   increase performance up to a point.  the\n"
         "                   ideal value is different for every system.\n"
         "                   there is a direct correlation between higher\n"
         "                   values and higher memory usage.  also,\n"
         "                   beyond a certain point there is no\n"
         "                   improvement.  this gives up some of the\n"
         "                   fine-grained error/scratch-detection that\n"
         "                   cdstatus was designed for, so this still\n"
         "                   defaults to 1, but you now have the option.\n\n"
         "--cddb             instruct cdstatus to calculate the cddb disc\n"
         "                   id and contact the remote cddb database server\n"
         "                   to look up the album information. see --format\n\n"
         "--no-cddb          overrides user .cdstatus config choice and\n"
         "                   disables cddb lookup\n\n"
         "--format           used to specify filename format for output files.\n"
         "                   only valid when used with --cddb.  syntax is:\n\n"
         "                   #Artist#      -> Becomes artist name\n"
         "                   #Album#       -> Becomes name of cd\n"
         "                   #TrkNum#      -> Becomes track number, like 01\n"
         "                   #TrkName#     -> Becomes track name\n\n"
         "                   see README for example.  Other characters are \n" "                   allowed freeform.\n");
}
